3 # Copyright (c) 2005, 2006 Junio C Hamano
5 USAGE
='[--signoff] [--dotest=<dir>] [--utf8 | --no-utf8] [--binary] [--3way]
6 [--interactive] [--whitespace=<option>] [-C<n>] [-p<n>] <mbox>...
7 or, when resuming [--skip | --resolved]'
12 git var GIT_COMMITTER_IDENT
>/dev
/null ||
exit
15 echo "$1" >"$dotest/next"
19 stop_here_user_resolve
() {
20 if [ -n "$resolvemsg" ]; then
24 cmdline
=$
(basename $0)
25 if test '' != "$interactive"
29 if test '' != "$threeway"
33 if test '.dotest' != "$dotest"
35 cmdline
="$cmdline -d=$dotest"
37 echo "When you have resolved this problem run \"$cmdline --resolved\"."
38 echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
44 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
45 "$dotest/patch" "$dotest/info"
46 echo "$next" >"$dotest/next"
52 echo "Cannot fall back to three-way merge."
57 O_OBJECT
=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
59 rm -fr "$dotest"/patch-merge-
*
60 mkdir
"$dotest/patch-merge-tmp-dir"
62 # First see if the patch records the index info that we can use.
63 git-apply
-z --index-info "$dotest/patch" \
64 >"$dotest/patch-merge-index-info" &&
65 GIT_INDEX_FILE
="$dotest/patch-merge-tmp-index" \
66 git-update-index
-z --index-info <"$dotest/patch-merge-index-info" &&
67 GIT_INDEX_FILE
="$dotest/patch-merge-tmp-index" \
68 git-write-tree
>"$dotest/patch-merge-base+" ||
69 cannot_fallback
"Patch does not record usable index information."
71 echo Using index info to reconstruct a base tree...
72 if GIT_INDEX_FILE
="$dotest/patch-merge-tmp-index" \
73 git-apply
$binary --cached <"$dotest/patch"
75 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
76 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
78 cannot_fallback
"Did you hand edit your patch?
79 It does not apply to blobs recorded in its index."
82 test -f "$dotest/patch-merge-index" &&
83 his_tree
=$
(GIT_INDEX_FILE
="$dotest/patch-merge-index" git-write-tree
) &&
84 orig_tree
=$
(cat "$dotest/patch-merge-base") &&
85 rm -fr "$dotest"/patch-merge-
* ||
exit 1
87 echo Falling back to patching base and
3-way merge...
89 # This is not so wrong. Depending on which base we picked,
90 # orig_tree may be wildly different from ours, but his_tree
91 # has the same set of wildly different changes in parts the
92 # patch did not touch, so recursive ends up canceling them,
93 # saying that we reverted all those changes.
95 eval GITHEAD_
$his_tree='"$SUBJECT"'
96 export GITHEAD_
$his_tree
97 git-merge-recursive
$orig_tree -- HEAD
$his_tree ||
{
98 if test -d "$GIT_DIR/rr-cache"
102 echo Failed to merge
in the changes.
105 unset GITHEAD_
$his_tree
109 dotest
=.dotest sign
= utf8
=t keep
= skip
= interactive
= resolved
= binary
= resolvemsg
=
112 while case "$#" in 0) break;; esac
115 -d=*|
--d=*|
--do=*|
--dot=*|
--dote=*|
--dotes=*|
--dotest=*)
116 dotest
=`expr "z$1" : 'z-[^=]*=\(.*\)'`; shift ;;
117 -d|
--d|
--do|
--dot|
--dote|
--dotes|
--dotest)
118 case "$#" in 1) usage
;; esac; shift
121 -i|
--i|
--in|
--int|
--inte|
--inter|
--intera|
--interac|
--interact|\
122 --interacti|
--interactiv|
--interactive)
123 interactive
=t
; shift ;;
125 -b|
--b|
--bi|
--bin|
--bina|
--binar|
--binary)
128 -3|
--3|
--3w|
--3wa|
--3way)
130 -s|
--s|
--si|
--sig|
--sign|
--signo|
--signof|
--signoff)
132 -u|
--u|
--ut|
--utf|
--utf8)
133 utf8
=t
; shift ;; # this is now default
134 --no-u|
--no-ut|
--no-utf|
--no-utf8)
136 -k|
--k|
--ke|
--kee|
--keep)
139 -r|
--r|
--re|
--res|
--reso|
--resol|
--resolv|
--resolve|
--resolved)
145 --whitespace=*|
-C*|
-p*)
146 git_apply_opt
="$git_apply_opt $1"; shift ;;
149 resolvemsg
=$
(echo "$1" |
sed -e "s/^--resolvemsg=//"); shift ;;
160 # If the dotest directory exists, but we have finished applying all the
161 # patches in them, clear it out.
162 if test -d "$dotest" &&
163 last
=$
(cat "$dotest/last") &&
164 next
=$
(cat "$dotest/next") &&
166 test "$next" -gt "$last"
173 case "$#,$skip$resolved" in
175 # Explicit resume command and we do not have file, so
179 # No file input but without resume parameters; catch
180 # user error to feed us a patch from standard input
181 # when there is already .dotest. This is somewhat
182 # unreliable -- stdin could be /dev/null for example
183 # and the caller did not intend to feed us a patch but
184 # wanted to continue unattended.
191 die
"previous dotest directory $dotest still exists but mbox given."
194 # Make sure we are not given --skip nor --resolved
195 test ",$skip,$resolved," = ,,, ||
196 die
"Resolve operation not in progress, we are not resuming."
199 mkdir
-p "$dotest" ||
exit
201 git-mailsplit
-d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" ||
{
206 # -b, -s, -u, -k and --whitespace flags are kept for the
207 # resuming session after a patch failure.
208 # -3 and -i can and must be given when resuming.
209 echo "$binary" >"$dotest/binary"
210 echo " $ws" >"$dotest/whitespace"
211 echo "$sign" >"$dotest/sign"
212 echo "$utf8" >"$dotest/utf8"
213 echo "$keep" >"$dotest/keep"
214 echo 1 >"$dotest/next"
219 files
=$
(git-diff-index
--cached --name-only HEAD
) ||
exit
220 if [ "$files" ]; then
221 echo "Dirty index: cannot apply patches (dirty: $files)" >&2
226 if test "$(cat "$dotest/binary
")" = t
228 binary
=--allow-binary-replacement
230 if test "$(cat "$dotest/utf8
")" = t
236 if test "$(cat "$dotest/keep
")" = t
240 ws
=`cat "$dotest/whitespace"`
241 if test "$(cat "$dotest/sign
")" = t
243 SIGNOFF
=`git-var GIT_COMMITTER_IDENT | sed -e '
245 s/^/Signed-off-by: /'
251 last
=`cat "$dotest/last"`
252 this
=`cat "$dotest/next"`
255 if test -d "$GIT_DIR/rr-cache"
259 this
=`expr "$this" + 1`
263 if test "$this" -gt "$last"
270 while test "$this" -le "$last"
272 msgnum
=`printf "%0${prec}d" $this`
273 next
=`expr "$this" + 1`
274 test -f "$dotest/$msgnum" ||
{
280 # If we are not resuming, parse and extract the patch information
281 # into separate files:
282 # - info records the authorship and title
283 # - msg is the rest of commit log message
284 # - patch is the patch body.
286 # When we are resuming, these files are either already prepared
287 # by the user, or the user can tell us to do so by --resolved flag.
290 git-mailinfo
$keep $utf8 "$dotest/msg" "$dotest/patch" \
291 <"$dotest/$msgnum" >"$dotest/info" ||
293 git-stripspace
< "$dotest/msg" > "$dotest/msg-clean"
297 GIT_AUTHOR_NAME
="$(sed -n '/^Author/ s/Author: //p' "$dotest/info
")"
298 GIT_AUTHOR_EMAIL
="$(sed -n '/^Email/ s/Email: //p' "$dotest/info
")"
299 GIT_AUTHOR_DATE
="$(sed -n '/^Date/ s/Date: //p' "$dotest/info
")"
301 if test -z "$GIT_AUTHOR_EMAIL"
303 echo "Patch does not have a valid e-mail address."
307 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
309 SUBJECT
="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info
")"
310 case "$keep_subject" in -k) SUBJECT
="[PATCH] $SUBJECT" ;; esac
314 if test '' != "$SIGNOFF"
317 sed -ne '/^Signed-off-by: /p' \
318 "$dotest/msg-clean" |
322 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
323 test '' = "$LAST_SIGNED_OFF_BY" && echo
331 if test -s "$dotest/msg-clean"
334 cat "$dotest/msg-clean"
336 if test '' != "$ADD_SIGNOFF"
340 } >"$dotest/final-commit"
343 case "$resolved$interactive" in
345 # This is used only for interactive view option.
346 git-diff-index
-p --cached HEAD
>"$dotest/patch"
352 if test "$interactive" = t
355 die
"cannot be interactive without stdin connected to a terminal."
357 while test "$action" = again
359 echo "Commit Body is:"
360 echo "--------------------------"
361 cat "$dotest/final-commit"
362 echo "--------------------------"
363 printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
367 [aA
]*) action
=yes interactive
= ;;
368 [nN
]*) action
=skip
;;
369 [eE
]*) "${VISUAL:-${EDITOR:-vi}}" "$dotest/final-commit"
372 LESS
=-S ${PAGER:-less} "$dotest/patch" ;;
380 if test $action = skip
386 if test -x "$GIT_DIR"/hooks
/applypatch-msg
388 "$GIT_DIR"/hooks
/applypatch-msg
"$dotest/final-commit" ||
393 echo "Applying '$SUBJECT'"
398 git-apply
$git_apply_opt $binary --index "$dotest/patch"
402 # Resolved means the user did all the hard work, and
403 # we do not have to do any patch application. Just
404 # trust what the user has in the index file and the
407 changed
="$(git-diff-index --cached --name-only HEAD)"
408 if test '' = "$changed"
410 echo "No changes - did you forget to use 'git add'?"
411 stop_here_user_resolve
$this
413 unmerged
=$
(git-ls-files
-u)
414 if test -n "$unmerged"
416 echo "You still have unmerged paths in your index"
417 echo "did you forget to use 'git add'?"
418 stop_here_user_resolve
$this
421 if test -d "$GIT_DIR/rr-cache"
428 if test $apply_status = 1 && test "$threeway" = t
432 # Applying the patch to an earlier tree and merging the
433 # result may have produced the same tree as ours.
434 changed
="$(git-diff-index --cached --name-only HEAD)"
435 if test '' = "$changed"
437 echo No changes
-- Patch already applied.
441 # clear apply_status -- we have successfully merged.
445 if test $apply_status != 0
447 echo Patch failed
at $msgnum.
448 stop_here_user_resolve
$this
451 if test -x "$GIT_DIR"/hooks
/pre-applypatch
453 "$GIT_DIR"/hooks
/pre-applypatch || stop_here
$this
456 tree
=$
(git-write-tree
) &&
457 echo Wrote tree
$tree &&
458 parent
=$
(git-rev-parse
--verify HEAD
) &&
459 commit
=$
(git-commit-tree
$tree -p $parent <"$dotest/final-commit") &&
460 echo Committed
: $commit &&
461 git-update-ref
-m "$GIT_REFLOG_ACTION: $SUBJECT" HEAD
$commit $parent ||
464 if test -x "$GIT_DIR"/hooks
/post-applypatch
466 "$GIT_DIR"/hooks
/post-applypatch